<script>
  import { extent } from "d3-array";
  import { select } from "d3-selection";
  import { scaleLinear } from "d3-scale";
  import { axisBottom, axisLeft } from "d3-axis";

  // Properties
  export let data = [];
  export let maxValue = 0;
  export let selectedCity = "";
  export let shiftX = 0;

  // Dimensions
  const width = 200;
  const height = 250;
  const margin = { top: 20, right: 20, bottom: 20, left: 10 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  const radius = innerWidth/2

  let coords = [];
  let maxR = 100;

  $: if (data) {
    console.log("Data ready, maxValue is ", maxValue);
    for (let i = 0; i < data.length; i++) {
      console.log(i, "heating", maxR(data[i].heating), getX(i+1, maxR(data[i].heating)));
      console.log(i, "cooling", maxR(data[i].cooling), getX(i+1, maxR(data[i].cooling)));
      let heatingValue = maxR(data[i].heating);
      let coolingValue = maxR(data[i].cooling);
      coords[i] = {heating: {x: getX(i+1, heatingValue), y: getY(i+1, heatingValue)}, cooling: {x: getX(i+1, coolingValue), y: getY(i+1, coolingValue)}}
    }
    console.log(coords);
  }

  function getX(month, polar_value) {
    return innerWidth / 2 + (polar_value * Math.cos(toRadians(twelve(-month))));
  }
  function getY(month, polar_value) {
    return innerHeight / 2 - (polar_value * Math.sin(toRadians(twelve(-month))));
  }

  function toRadians (angle) {
    return angle * (Math.PI / 180);
  }

  // Scales
  const twelve = scaleLinear()
    .range([90, 450])
    .domain([-12, 0]);
  $: maxR = scaleLinear()
    .range([0, radius])
    .domain([0, maxValue]);


</script>

<svg viewBox="0 0 {width} {height}" class="mx-3" style="max-width: {width}px">
  <g transform="translate({margin.left+shiftX},{margin.top})">
    <circle cx={innerWidth/2} cy={innerHeight/2} r={radius} stroke="black" stroke-width="2" fill="white"/>
    <line x1=0 y1="{innerHeight/2}" x2="{radius*2}" y2="{innerHeight/2}" stroke="black"  stroke-width="2"/>
    <line x1={innerWidth/2} y1="{innerHeight/2-radius}" x2="{innerWidth/2}" y2="{innerHeight/2+radius}" stroke="black"  stroke-width="2"/>
    <text x={innerWidth/2} y=0 text-anchor="middle" alignment-base="middle">{selectedCity}</text>
    <text x={innerWidth/2} y={margin.top-3} text-anchor="middle" alignment-base="middle">0</text>
    <text x={innerWidth/2} y={innerHeight-margin.top/4+2} text-anchor="middle" alignment-base="middle">6</text>
    <text x={innerWidth+margin.left/2+2} y={innerHeight/2+margin.top/4} text-anchor="middle" alignment-base="middle">3</text>
    <text x={-margin.left/2-2} y={innerHeight/2+margin.top/4} text-anchor="middle" alignment-base="middle">9</text>
    <g>
      {#each coords as c}
          <circle cx={c.heating.x} cy={c.heating.y} r="3" stroke="red" fill="red"/>
          <circle cx={c.cooling.x} cy={c.cooling.y} r="3" stroke="blue" fill = "blue"/>
      {/each}
    </g>
  </g>
</svg>
